
//  ASL STACK LIBRARY 
//
//  ASL (Abstract Schema Language) Stack Library
//
//
//
//  FILE NAME   : aslstack.h
//  MODULE TYPE : ASL stack Library
//  STATUS      : Ready for use 
//  PURPOSE     : General Stack Library
//  
//
//  Instituto Tecnologico Autonomo de Mexico 
//  (c) Copyrigth 1995  
//
//
//
//  HISTORY : Version (Date-Name) Modification, description. 
//
//            1.0 (Dec 30, 1995 - Claudia Calderas & Salvador Marmol), 
//            Start of development for distributed execution.

#pragma interface

#ifndef __ASL_STACK
#define __ASL_STACK 1

#include "asllist.h"

template <class T>
class AslStack
{
protected:
	AslList<T>* list;
public:
	AslStack(void);
	~AslStack(void);

	void push(T*);
	T*   pop(void);

	int  numberOfElements(void);
	int  isEmpty(void);
};

template <class T> AslStack<T>::AslStack(void)
{
	list = new AslList<T>;	
}

template <class T> AslStack<T>::~AslStack(void)
{
	delete list;		
}

template <class T> int AslStack<T>::isEmpty(void)
{
	return list->isEmpty();		
}

template <class T> int AslStack<T>::numberOfElements(void)
{
	return list->numberOfElements();
}

template <class T> void AslStack<T>::push(T* data)
{
	list->insert(data);
}

template <class T> T* AslStack<T>::pop(void)
{
	T *data;

	data = list->removeThis();
	list->startOnBottom();

	return data;
}

#endif
