/* SCCS  %W%---%E%--%U% */
//
//	nsl_input_3d.h
//

class nsl_input_3d : public nsl_input_matrix 
{
protected:
	nsl_num_0 zz;			// matrix zero elements
	nsl_num_0 dz;
	nsl_num_2 xzview;
	nsl_num_0 transx, transy;	// translation to origin
	nsl_num_0 angle;			// angle of rotation in radians: degrees/180=radians/PI
public:

	nsl_input_3d(const char*,nsl_public*,const int,const int,
		const int,const int,int=0,int=1,int=1);
	~nsl_input_3d();

	nsl_input_layer* get_input_layer() { return input_layer; }

// set
	void	set_zz(int i) { zz = i; }
	void	set_dz(float s) { dz = s; }

 	void	set_transx(float i) { transx = i; }
	void	set_transy(float i) { transy = i; }
	void	set_angle(float s) { angle = s; }

	void	set_xzview(nsl_num_2& m) { xzview = m; }

// get
	int	get_zz() { return (int) zz.get_value() + 0.5; }
	float	get_dz() { return dz.get_value(); }

 	float	get_transx() { return transx.get_value(); }
	float	get_transy() { return transy.get_value(); }
	float	get_angle() { return angle.get_value(); }

	nsl_num_2*	get_xzview_ptr() { return &xzview; }
	nsl_num_2	get_xzview() { return xzview; }

// 	assignment
	nsl_num_2& 	operator=(const nsl_input_3d&);
	nsl_num_2& 	operator=(const nsl_matrix&);
	nsl_num_2& 	operator=(const nsl_data&);
 	nsl_num_2& 	operator=(const num_type);
	nsl_num_2& 	operator=(const int);

 	int run();

// print status
	virtual int print_status(ostream&) const;
	int print_input_3d_status(ostream&) const;

	virtual int print(ostream&) const;
	virtual int print(ostream&,int) const;
};
