/* SCCS  %W%---%E%--%U% */
//
//	nsl_stim_3d.h
//

class nsl_stim_3d : public nsl_stim_matrix
{
protected:
	nsl_num_0 angle;	// stim current direction angle
	nsl_num_0 z0;		// stim current corner location
	nsl_num_0 tz0;		// stim current corner location
	nsl_num_0 zc;		// stim original center location
	nsl_num_0 tzc;		// stim current center location
	nsl_num_0 dz; 		// stim size
	nsl_num_0 vz; 		// stim speed

public:

	nsl_stim_3d(nsl_input_3d*);
 	~nsl_stim_3d();

// set
 	void	set_angle(float i) { angle = i; }
 	void	set_z0(float i) { z0 = i; }
	void	set_tz0(float i) { tz0 = i; }
	void	set_zc(float i) { zc = i; }
	void	set_tzc(float i) { tzc = i; }
	void	set_dz(float s) { dz = s; }
	void	set_vz(float s) { vz = s; }

// get
 	float	get_angle() { return angle.get_value(); }
 	float	get_z0() { return z0.get_value(); }
	float	get_tz0() { return tz0.get_value(); }
	float	get_zc() { return zc.get_value(); }
	float	get_tzc() { return tzc.get_value(); }
	float	get_dz() { return dz.get_value(); }
	float	get_vz() { return vz.get_value(); }

	virtual int run();
	virtual int proc();

	virtual int print(ostream&) const;
	int print_stim_3d(ostream&) const;
	virtual int print_status(ostream&) const;
	int print_stim_3d_status(ostream&) const;
};


