/* SCCS  @(#)nsl_cmd_stim.C	1.1---95/08/13--20:52:41 */
/**************************************************************/
/*                                                            */
/*                   nsl_cmd_stim.C                   	      */
/*                                                            */
/**************************************************************/

# include "nsl_all_kernel_include.h"
# include "nsl_all_input_include.h"

nsl_cmd_stim::nsl_cmd_stim() : nsl_cmd_type("stim")
{
	set_base_type("stim");
	set_type("stim");
}

nsl_cmd_stim::~nsl_cmd_stim()
{
}

int nsl_cmd_stim::cmd_clear(nsl_interpreter& nsl)
{
	cmd_type_clear(nsl);

 	return 1;
}

int nsl_cmd_stim::cmd_create(nsl_interpreter& nsl)
{
        nsl_base* base;
        nsl_cmd_type* cmd_obj;
        nsl_string str;
 	nsl_list* list = 0;
        nsl_layer *data,*layer;
	const char *lname = "";
	        
        strcpy(str,get_obj_name(nsl));

        // change to "command_modifiers"
        cmd_init(nsl); // user assigned options on create command
     
     	if (m_parent == NULL) {
                cmd_error("CMD: NULL PARENT");
                return 0;
        }
        
        if ((cmd_obj = (nsl_cmd_type*) 
	    SYSTEM->get_cmd_system()->get_m_children_list()
		->get_mi_by_type(get_base_type())) != NULL	
	    && (list = cmd_obj->get_data_list()) != NULL)
        {
            if ((data = (nsl_layer*) list->get_by_name("layer")) != NULL)
	    {
                lname = ((nsl_str_data*) data)->get_value();
		if ((layer = (nsl_layer*) get_hier_object(lname,0)) != NULL)
		{
			m_parent->set_ptr(layer);
		}
	    }
            else
                cmd_error("cmd_stim: NULL 'layer' obj");
 
            if ((data = (nsl_layer*) list->get_by_name("name")) != NULL)
	    {
                ((nsl_str_data*) data)->set_value(str);
	    }
            else
                cmd_error("cmd_stim: NULL 'name' obj");       
        }
        
        if (i_children_list != NULL &&
                (base = (nsl_base*) m_parent->get_ptr()) != NULL &&
                (cmd_obj = (nsl_cmd_type*) i_children_list->
                get_by_type_and_name(base->get_type(),get_type())) != NULL)
        {
                cmd_obj->cmd_create(nsl);
        }
        else
                cmd_error("CMD: NULL OBJ");

        //	cmd_type_create(nsl);

	return 1;
}
int nsl_cmd_stim::cmd_reset(nsl_interpreter& nsl)
{
	cmd_type_reset(nsl);

	return 1;
}
int nsl_cmd_stim::cmd_update(nsl_interpreter& nsl)
{
	cmd_type_update(nsl);

	return 1;
}
int nsl_cmd_stim::init_data(nsl_base* stim)
{
 	int ival;
	nsl_cmd_type* data;
 	nsl_base* pbase;
	nsl_list* list = 0;
	on_off_enum spec_view;

	pbase = SYSTEM->get_cmd_system()->
	     get_m_children_list()->get_mi_by_type(get_base_type());
	if (pbase != NULL)
		list = ((nsl_cmd_type*) pbase)->get_data_list();
	else
		cmd_error("cmd: NULL parent type");
	if (list != NULL)
	{
	  if ((data = (nsl_cmd_type*) list->get_by_name("spec_view")) != NULL)
	  {
		spec_view = ((nsl_on_off_data*) data)->get_value();
		((nsl_stim*) stim)->set_spec_view(spec_view);
	  }
	  else
		cmd_error("nsl_cmd_stim: NULL 'stim_type' obj");

	  if ((data = (nsl_cmd_type*) list->get_by_name("step")) != NULL)
	  {
		ival = ((nsl_int_data*) data)->get_value();
		((nsl_stim*) stim)->set_step(ival);
	  }
 	  else
		cmd_error("nsl_cmd_stim: NULL 'name' obj");
	}

	return 1;
}
int nsl_cmd_stim::update_data(nsl_base* stim,
	int,int,int,int,int,int,int,int,int,int)
{
 	int ival;
	nsl_cmd_type* data;
	nsl_base* pbase;
	nsl_list* list = 0;
	on_off_enum spec_view;

	pbase = SYSTEM->get_cmd_system()->
	     get_m_children_list()->get_mi_by_type(get_base_type());
	if (pbase != NULL)
		list = ((nsl_cmd_type*) pbase)->get_data_list();
	else
		cmd_error("cmd: NULL parent type");
	if (list != NULL)
	{
	  if ((data = (nsl_cmd_type*) list->get_by_name("step")) != NULL)
	  {
		ival = ((nsl_int_data*) data)->get_value();
		((nsl_stim*) stim)->set_step(ival);
	  }
	  else
		cmd_error("nsl_cmd_stim: NULL 'step' obj");

	  if ((data = (nsl_cmd_type*) list->get_by_name("spec_view")) != NULL)
	  {
		spec_view = ((nsl_on_off_data*) data)->get_value();
		((nsl_stim*) stim)->set_spec_view(spec_view);
	  }
	  else
		cmd_error("nsl_cmd_stim: NULL 'spec_view' obj");
	}

	return 1;
}

