/* SCCS  %W%---%E%--%U% */
//
//	nsl_spec_type_data.C
//

# include "nsl_all_kernel_include.h"
# include "nsl_all_input_include.h"

nsl_spec_type_data::nsl_spec_type_data(int sfg,int fg,int rfg) : 
	nsl_data_layer(sfg,fg,rfg)
{
	init_spec_type_data();
}
nsl_spec_type_data::nsl_spec_type_data(const char* str,nsl_model* m,int sfg,int fg,
	int rfg) : nsl_data_layer("spec_type_data",str,m,sfg,fg,rfg)
{
	init_spec_type_data();
}
nsl_spec_type_data::nsl_spec_type_data(const char* str,const spec_type_enum val,
	nsl_model* m,int sfg,int fg,int rfg) : 
	nsl_data_layer("spec_type_data",str,m,sfg,fg,rfg)
{
	init_spec_type_data();
	sval = val;
}

nsl_spec_type_data::nsl_spec_type_data(const nsl_spec_type_data& a,int sfg,int fg,
	int rfg) : nsl_data_layer(sfg,fg,rfg)
{
	init_spec_type_data();
	sval = a.get_value();
}

// nsl_spec_type_data destructors

nsl_spec_type_data::~nsl_spec_type_data()
{
}

// init

int nsl_spec_type_data::init_spec_type_data()
{
	sval = NSL_CORNER;
	return 1;
}

// nsl_spec_type_data set values

spec_type_enum nsl_spec_type_data::set_value(const spec_type_enum val)
{
	sval = val;
	return sval;
}

// nsl_spec_type_data assignment

spec_type_enum nsl_spec_type_data::operator=(const nsl_spec_type_data& a)
{
	sval = a.get_value();
	return sval;
}
spec_type_enum nsl_spec_type_data::operator=(const spec_type_enum val)
{
	sval = val;
	return sval;
}

// print

int nsl_spec_type_data::print_spec_type_data_status(ostream& out) const
{
	print_data_layer_status(out);
	return 1;
}
int nsl_spec_type_data::print_status(ostream& out) const
{
	print_spec_type_data_status(out);
	return 1;
}
int nsl_spec_type_data::print_spec_type_data(ostream& out) const
{
	print_data_layer(out);
	out <<  sval << "\n";
	out.flush();
	return 1;
}
int nsl_spec_type_data::print(ostream& out) const
{
	print_spec_type_data(out);
	return 1;
}

int nsl_spec_type_data::reset_spec_type_data(nsl_buffer* buf)
{
	if (buf == NULL)
		sval = NSL_CORNER;
//	else
//		*buf >> sval;

	return 1;
}
int nsl_spec_type_data::reset(nsl_buffer* buf)
{
	reset_spec_type_data(buf);
	return 1;
}

int nsl_spec_type_data::write_spec_type_data(nsl_buffer& buf)
{
	buf << sval;
	return 1;
}
int nsl_spec_type_data::write(nsl_buffer& buf)
{
	write_spec_type_data(buf);
	return 1;
}
int nsl_spec_type_data::read_spec_type_data(nsl_buffer& buf)
{
	nsl_string str;
	buf >> str;

	if (strcmp(str,"NSL_CORNER") == 0)
		sval = NSL_CORNER;
	else if (strcmp(str,"NSL_CENTER") == 0)
		sval = NSL_CENTER;
	else
		cmd_error("spec_type_data:read: BAD string: ",str);

	return 1;
}
int nsl_spec_type_data::read(nsl_buffer& buf)
{
	read_spec_type_data(buf);
	return 1;
}


