/* SCCS  @(#)nsl_system.h	1.1---95/08/13--23:37:23 */
//
// 	nsl_system.h
//

class nsl_system : public nsl_public
{
protected:
	nsl_num_0 simDelta;		// simulation time step
	nsl_num_0 trainDelta;	// train time step
	nsl_num_0 simSysTime;	// simulation absolute time
	nsl_num_0 trainSysTime;	// train absolute time
	
	nsl_num_0 simCurrentTime;	// simulation current time
	int simCurrentTimeStep; // simulation current time step
	nsl_num_0 trainCurrentTime;	// train current time
	int trainCurrentTimeStep; // train current time step
	
	nsl_num_0 simEndTime;	// simulation end time
	int simEndTimeStep;	// simulation end time step
	nsl_num_0 trainEndTime;	// train end time
	int trainEndTimeStep;	// train end time step
			
	nsl_num_0 simAccumCurrentTime; // sim accumulated current time
	int simAccumCurrentTimeStep; // sim accumulated current time step
	nsl_num_0 trainAccumCurrentTime; // train accumulated current time
	int trainAccumCurrentTimeStep; // train accumulated current time step

	nsl_num_0 epochSteps;	// epoch steps (int)
	nsl_num_0 epochStep;	// epoch step (int)	

// current pointer
	on_off_enum xsystem_fg;		// ON - Window interface
//	nsl_interpreter* INTERPRETER;	// interpreter
 
	int model_total; 		// total number of models
	nsl_list* model_list; 		// pointer to all models

	int model_application_total; 	// total number of application models
	nsl_list* model_application_list; // pointer to all application models
	
	int proc_total; 		// total number of system procs
	nsl_list* proc_list; 		// pointer to all system procs

	int diff_method_total; 		// total number of diff methods
	nsl_list* diff_method_list; 	// pointer to all diff methods

	int diff_model_total; 		// total number of diff models
	nsl_list* diff_model_list; 	// pointer to all diff models

	nsl_diff_manager* DIFFM;	// diff information

	int thresh_lib_total; 		// total number of thresh libraries
	nsl_list* thresh_lib_list; 	// pointer to all thresh libraries

// i/o files
	nsl_string nsl_dir;		// nsl system directory
 
	int file_type_total; 		// total number of file types
	nsl_list* file_type_list;   	// pointer to file list types

	nsl_file_manager* fm;		// file manager

// cmds
	nsl_cmd_system* sys;		// cmd_system root

 // system
	int* argc_ptr;
	char** argv_ptr;
	
public:
		nsl_system();
		virtual ~nsl_system();

// get	
	float getSimDelta() { return simDelta.get_value(); }
	float getSimSysTime() { return simSysTime.get_value(); }
	float getSimEndTime() { return simEndTime.get_value(); }
	int getSimEndTimeStep() { return simEndTimeStep; }
	float getSimTime() { return simCurrentTime.get_value(); }
	float getSimCurrentTime() { return simCurrentTime.get_value(); }
	int getSimTimeStep() { return simCurrentTimeStep; }
	int getSimCurrentTimeStep() { return simCurrentTimeStep; }

	float getSimAccumTime() { return simAccumCurrentTime.get_value(); }	
	float getSimAccumCurrentTime() { return simAccumCurrentTime.get_value(); }
	int getSimAccumCurrentTimeStep() { return simAccumCurrentTimeStep; }

	float getTrainDelta() { return trainDelta.get_value(); }
	float getTrainSysTime() { return trainSysTime.get_value(); }
	float getTrainEndTime() { return trainEndTime.get_value(); }
	int getTrainEndTimeStep() { return trainEndTimeStep; }
	float getTrainTime() { return trainCurrentTime.get_value(); }
	float getTrainCurrentTime() { return trainCurrentTime.get_value(); }
	int getTrainTimeStep() { return trainCurrentTimeStep; }
	int getTrainCurrentTimeStep() { return trainCurrentTimeStep; }

	float getTrainAccumTime() { return trainAccumCurrentTime.get_value(); }	
	float getTrainAccumCurrentTime() { return trainAccumCurrentTime.get_value(); }
	int getTrainAccumCurrentTimeStep() { return trainAccumCurrentTimeStep; }
			
	int getEpochSteps() { return (int) epochSteps.get_value(); }
	int getEpochStep() { return (int) epochStep.get_value(); }
	
// set
	void 	setSimDelta(float f) { simDelta = f; }
	void	setSimSysTime(float f) { simSysTime = f; }
	void 	setSimTime(float);
	void 	setSimTime(int); // check out this
	void 	setSimEndTime(float);
	void 	setSimCurrentTime(float f) { setSimTime(f); }
	void 	setSimTimeStep(int);
	void 	setSimEndTimeStep(int);
	void 	setSimCurrentTimeStep(int f) { setSimTime(f); }
	
	void 	setSimAccumTime(float);
	void 	setSimAccumCurrentTimeStep(int f) { setSimAccumTime(f); }
	void 	setSimAccumCurrentTime(float f) { setSimAccumTime(f); }

	void 	setTrainDelta(float f) { trainDelta = f; }
	void	setTrainSysTime(float f) { trainSysTime = f; }
	void 	setTrainTime(float);
	void 	setTrainTime(int); // check out this
	void 	setTrainEndTime(float);
	void 	setTrainCurrentTime(float f) { setTrainTime(f); }
	void 	setTrainTimeStep(int);
	void 	setTrainEndTimeStep(int);
	void 	setTrainCurrentTimeStep(int f) { setTrainTime(f); }

	void 	setTrainAccumTime(float);
	void 	setTrainAccumCurrentTimeStep(int f) { setTrainAccumTime(f); }
	void 	setTrainAccumCurrentTime(float f) { setTrainAccumTime(f); }
	
	void setEpochSteps(int i) { epochSteps = i; }
	void setEpochStep(int i) { epochStep = i; }
		
// reset time
	void resetSimTime();
	void resetTrainTime();
// increment time 
	void incrSimTime();
	void incrSimSysTime() { simSysTime = simSysTime + 1; }
	void incrTrainTime();
	void incrTrainSysTime() { trainSysTime = trainSysTime + 1; }

	void		set_xsystem_fg(on_off_enum fg) { xsystem_fg = fg; }
	on_off_enum	get_xsystem_fg() { return xsystem_fg; }

// model
	int		add_model(nsl_model*);
	nsl_model*	get_model() { return (nsl_model*) get_ptr(); } 
	nsl_model*	get_model(const int);		// index search
/* AW99
	int 	get_model_total() { return model_total; }
	nsl_list* get_model_list() { return model_list; }

	nsl_model*	get_model(const char*);		// name search

	void		set_model(nsl_model* m) { set_ptr((nsl_base*)m); }
*/	
	int addApplicationModel(nsl_model*);
	nsl_model* getApplicationModel(const char*);

// AW98 AslSchema methods
	virtual int initTrain(void) { return 1; }	
	virtual int simTrain(void) { return 1; }	
	virtual int endTrain(void) { return 1; }	
	virtual int initRun(void) { return 1; }	
	virtual int simRun(void) { return 1; }	
	virtual int endRun(void) { return 1; }	
	virtual int initSys(void) { return 1; }	
	virtual int endSys(void) { return 1; }	
	virtual int initModule(void) { return 1; }	
	virtual int endModule(void) { return 1; }	
	
// procedure
	int 	get_proc_total() { return proc_total; }
	nsl_list* get_proc_list() { return proc_list; }

	int		insert_proc(nsl_function*);
	int		add_proc(nsl_function*);
	nsl_function*	get_proc(const char*);		// name search
	nsl_function*	get_proc(const int);		// index search

	int 		init();
	int 		init_proc();

// diff method
	int 	get_diff_method_total() { return diff_method_total; }
	nsl_list* get_diff_method_list() { return diff_method_list; }

	int		add_diff_method(nsl_diff_method*);
	nsl_diff_method*	get_diff_method(const char*);

// diff model
	int 	get_diff_model_total() { return diff_model_total; }
	nsl_list* get_diff_model_list() { return diff_model_list; }

	int		add_diff_model(nsl_diff*);
	nsl_diff*	get_diff_model(const char*); // nsl_diff_model

// diff manager
	nsl_diff_manager* get_diff_manager() { return DIFFM; }
	void 	set_diff_manager(nsl_diff_manager* d) { DIFFM = d; }

// thresh
	int 	get_thresh_lib_total() { return thresh_lib_total; }
	nsl_list* get_thresh_lib_list() { return thresh_lib_list; }

	int		add_thresh_lib(nsl_thresh_library*);
	nsl_thresh_library*	get_thresh_lib(const char*);

// interpreter
//	void		set_interpreter(nsl_interpreter* m) { NSL = m; }
//	nsl_interpreter* get_interpreter() { return NSL; } 

// i/o file
	char* 	get_nsl_dir() { return nsl_dir; }
	void 	set_nsl_dir(const char* str) { strcpy(nsl_dir,str); }
 
	int 	get_file_type_total() { return file_type_total; }
	nsl_list* get_file_type_list() { return file_type_list; }

	int		add_file_type(nsl_file*);
	nsl_file*	get_file_type(const char*);	// name search
	nsl_file*	get_file_type(const int);	// index search

	nsl_file_manager* get_file_manager() { return fm; }

// cmds
	nsl_cmd_system* get_cmd_system() { return sys; }
	void set_cmd_system(nsl_cmd_system* s) { sys = s; }

// system
	void set_argc_ptr(int* ptr) { argc_ptr = ptr; }
	int* get_argc_ptr() { return argc_ptr; }
	void set_argv_ptr(char** ptr) { argv_ptr = ptr; }
	char** get_argv_ptr() { return argv_ptr; }

// print status
	int	init_system();

	int write_model(fstream*,nsl_model*);
	void print_layers(fstream*,nsl_model*);
	void print_models(fstream*,nsl_model*);

	virtual int 	print(ostream&) const;
	int 	print_system(ostream&) const;
	virtual int 	print_status(ostream&) const;
	int 	print_system_status(ostream&) const;

	virtual int 	print_all(ostream&) const;
	int 	print_system_all(ostream&) const;
	virtual int 	print_all_status(ostream&) const;
	int 	print_system_all_status(ostream&) const;

	int 	write_system(nsl_buffer&);
	virtual int 	write(nsl_buffer&);
	int 	read_system(nsl_buffer&);
	virtual int 	read(nsl_buffer&);
};
