/* SCCS  %W%---%E%--%U% */
//
// nsl_nsl_file_stream_library.C
//

# include "nsl_all_kernel_include.h"

nsl_file& operator>>(nsl_file& f,unsigned char& data)
{
	fstream* fs;

	if ((fs = f.get_file_stream()) != NULL)
		fs->get(data); // (*fs) >> data;
	else
		cmd_error("NULL fstream in nsl_file");

	return f;
}

nsl_file& operator<<(nsl_file& f,unsigned char& data)
{
	fstream* fs;

	if ((fs = f.get_file_stream()) != NULL)
		fs->put(data); // (*fs) << data;
	else
		cmd_error("NULL fstream in nsl_file");

	return f;
}

nsl_file& operator>>(nsl_file& f,char& data)
{
	fstream* fs;

	if ((fs = f.get_file_stream()) != NULL)
		(*fs) >> data;
	else
		cmd_error("NULL fstream in nsl_file");

	return f;
}

nsl_file& operator<<(nsl_file& f,char& data)
{
	fstream* fs;

	if ((fs = f.get_file_stream()) != NULL)
		(*fs) << data;
	else
		cmd_error("NULL fstream in nsl_file");

	return f;
}

nsl_file& operator>>(nsl_file& f,char* data)
{
	fstream* fs;

	if ((fs = f.get_file_stream()) != NULL)
		(*fs) >> data;
	else
		cmd_error("NULL fstream in nsl_file");

	return f;
}
nsl_file& operator<<(nsl_file& f,char* data)
{
	fstream* fs;

	if ((fs = f.get_file_stream()) != NULL)
		(*fs) << data;
	else
		cmd_error("NULL fstream in nsl_file");

	return f;
}

nsl_file& operator>>(nsl_file& f,int& data)
{
	fstream* fs;

	if ((fs = f.get_file_stream()) != NULL)
		(*fs) >> data;
	else
		cmd_error("NULL fstream in nsl_file");

	return f;
}

nsl_file& operator<<(nsl_file& f,int& data)
{
	fstream* fs;

	if ((fs = f.get_file_stream()) != NULL)
		(*fs) << data;
	else
		cmd_error("NULL fstream in nsl_file");

	return f;
}
nsl_file& operator>>(nsl_file& f,float& data)
{
	fstream* fs;

	if ((fs = f.get_file_stream()) != NULL)
		(*fs) >> data;
	else
		cmd_error("NULL fstream in nsl_file");

	return f;
}
nsl_file& operator<<(nsl_file& f,float& data)
{
	fstream* fs;

	if ((fs = f.get_file_stream()) != NULL)
		(*fs) << data;
	else
		cmd_error("NULL fstream in nsl_file");

	return f;
}

nsl_nsl_file& operator<<(nsl_nsl_file& f,char* str)
{
	fstream* fs;

	if ((fs = f.get_file_stream()) != NULL)
		(*fs) << str;
	else
		cmd_error("NULL fstream in nsl_nsl_file");

	return f;
}

istream& operator>>(istream& in,nsl_num_0& layer)
{
	in >> layer.elem();
 
	return in;
}

istream& operator>>(istream& in,nsl_num_1& layer)
{
	int i0 = layer.get_i0();
	int i1 = layer.get_i1();

	for (int i = i0; i <= i1; i++)
		in >> layer[i];
 
	return in;
}
istream& operator>>(istream& in,nsl_num_2& layer)
{
	int i0 = layer.get_i0();
	int i1 = layer.get_i1();
	int j0 = layer.get_j0();
	int j1 = layer.get_j1();

	for (int i = i0; i <= i1; i++)
	    for (int j = j0; j <= j1; j++)
		in >> layer[i][j];
 
	return in;
}
ostream& operator<<(ostream& out,nsl_num_0& layer)
{
	out << layer.elem();
 
	return out;
}

ostream& operator<<(ostream& out,nsl_num_1& layer)
{
	int i0 = layer.get_i0();
	int i1 = layer.get_i1();

	for (int i = i0; i <= i1; i++)
		out << layer[i];
 
	return out;
}
ostream& operator<<(ostream& out,nsl_num_2& layer)
{
	int i0 = layer.get_i0();
	int i1 = layer.get_i1();
	int j0 = layer.get_j0();
	int j1 = layer.get_j1();

	for (int i = i0; i <= i1; i++)
	    for (int j = j0; j <= j1; j++)
		out << layer[i][j];
 
	return out;
}
