/* SCCS  @(#)nsl_data_add_library.C	1.1---95/08/13--20:48:12 */
//
//	nsl_data_operator_add_library.C
//

# include "nsl_all_kernel_include.h"

// nsl_data addition
/* AW98
nsl_data operator+(const nsl_data& a)
{
#ifdef NSL_DEBUG
	cout << "// nsl_data  operator+\n";
	cout << "// (data) "<< " = + (data) ";
	cout << a.get_name() << ";\n";
	cout.flush();
#endif

	nsl_data c;
	c = a.get_data();
	return c;
}
nsl_data operator+(const nsl_data& a,const nsl_data& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_data  operator+\n";
	cout << "// (data) " << a.get_name() << " + (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_data c;
	c = a.get_data() + b.get_data();
	return c;
}
nsl_data operator+(const nsl_data& a,const num_type b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_data  operator+\n";
	cout << "// (data) " << a.get_name() << " + (num_type) ";
	cout << b << ";\n";
	cout.flush();
#endif

	nsl_data c;
	c = a.get_data() + b;
	return c;
}
*/
nsl_data operator+(const num_type a, const nsl_data& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_data  operator+\n";
	cout << "// (num_type) " << a << " + (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_data c;
	c = a + b.get_data();
	return c;
}

// add_equal

void NSLadd_equal(nsl_num_data& out,const nsl_num_matrix& a)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	out = 0;
	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		out = out + a[i][j];
}
void NSLadd_equal(nsl_num_data& out,const nsl_num_vector& a)
{
	int amax = a.get_imax();

	out = 0;
	for (int i = 0; i < amax; i++)
		out = out + a[i];
}
void NSLadd_equal(nsl_num_data& out,const nsl_num_data& a)
{
	out = a.get_data();
}

// add_plus

void NSLadd_plus(nsl_num_data& out,const nsl_num_matrix& a)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	out = 0;
	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		out = out + a[i][j];
}
void NSLadd_plus(nsl_num_data& out,const nsl_num_vector& a)
{
	int amax = a.get_imax();

	for (int i = 0; i < amax; i++)
		out = out + a[i];
}
void NSLadd_plus(nsl_num_data& out,const nsl_num_data& a)
{
	out.elem() += a.get_data();
}

// add_minus

void NSLadd_minus(nsl_num_data& out,const nsl_num_matrix& a)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	out = 0;
	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		out = out - a[i][j];
}
void NSLadd_minus(nsl_num_data& out,const nsl_num_vector& a)
{
	int amax = a.get_imax();

	for (int i = 0; i < amax; i++)
		out = out - a[i];
}
void NSLadd_minus(nsl_num_data& out,const nsl_num_data& a)
{
	out.elem() -= a.get_data();
}
