// exponential decay

nsl_matrix NSLexpdecay(nsl_matrix& T,nsl_data& kx1)
{            
        int imax = T.get_imax();
        int jmax = T.get_jmax();
             
        nsl_matrix Q(imax,jmax);
             
        int i0 = T.get_i0();
        int i1 = T.get_i1();
        int j0 = T.get_j0();
        int j1 = T.get_j1();
             
        num_type dt = NSL_MODEL->get_delta();
             
        int i,j;
        num_type val;
             
        for (i=i0; i<=i1; i++)
            for (j=j0; j<=j1; j++)
            {
                val = exp(-dt/kx1.elem());
                Q.elem(i,j) = val*T.elem(i,j);
            }

        return Q;
}

// build a Gaussian kernel (former KERNEL)

nsl_matrix nslGauss(int imax,int jmax,nsl_data& dia,nsl_data& sig,nsl_data& wgt)
{
        int i,j;
        num_type r,rad;

        nsl_matrix Q(imax,jmax);

//      int imax = Q.get_imax();
//      int jmax = Q.get_jmax();
        int imax2 = imax/2;
        int jmax2 = jmax/2;
             
        num_type rad0 = dia.elem()/2.0;
        num_type sum = 0.0;
        if (dia.elem() == 0.0)
                return Q;

        for (i=0; i<imax; i++)
            for (j=0; j<jmax; j++)
            {
                /* r is in units of 1/2 degrees, same as kernel array */
                r = (num_type) sqrt((num_type) pow((num_type)(i-imax2),2.0) + 
                        (num_type) pow((num_type)(j-jmax2),2.0));
                /* rad is in units of degrees */
                rad = r/2.0;
                if (rad < rad0)
                     Q.elem(i,j) = (num_type) 
                        exp(-(rad*rad)/(2.0*sig.elem()*sig.elem()));
                sum = sum + Q.elem(i,j);
            }

        if (sum == 0.0)
                Q = 0;
        else 
                Q = Q/sum*wgt;

        return Q;
}
