//
//	nsl_num_3_mult_library.C
//

# include "nsl_all_kernel_include.h"

void NSLmult_equal(nsl_num_3& out,const nsl_num_3& a,
	const num_type& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int outkmax = out.get_kmax();
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();

	if (aimax != outimax || ajmax != outjmax || akmax != outkmax)
	{
		cmd_error("NSLmult_equal: Inconsistent num_3 sizes");
		out.print_status(cerr);
		a.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
		for (int j = 0; j < outjmax; j++)
			for (int k = 0; k < outkmax; k++)
				out[i][j][k] = a[i][j][k] * b;
}

void NSLmult_plus(nsl_num_3& out,const nsl_num_3& a,
	const num_type& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int outkmax = out.get_kmax();
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();

	if (aimax != outimax || ajmax != outjmax || akmax != outkmax)
	{
		cmd_error("NSLmult_plus: Inconsistent num_3 sizes");
		out.print_status(cerr);
		a.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
		for (int j = 0; j < outjmax; j++)
			for (int k = 0; k < outkmax; k++)
				out[i][j][k] = out[i][j][k] + a[i][j][k] * b;
}

