/****************************************************************/
/*                                                           	*/
/*                  nsl_misc_library.h                          */
/*                                                            	*/
/****************************************************************/

// NSLmax
extern num_type NSLmax(const nsl_vector&);
extern num_type NSLmax(const nsl_matrix&);
extern nsl_data NSLmax(const nsl_data&,const nsl_data&);
extern nsl_data NSLmax(const nsl_data&,const num_type);
extern nsl_vector NSLmax(const nsl_vector&,const nsl_vector&);
extern nsl_vector NSLmax(const nsl_vector&,const nsl_data&);
extern nsl_vector NSLmax(const nsl_vector&,const num_type);
extern nsl_matrix NSLmax(const nsl_matrix&,const nsl_matrix&);
extern nsl_matrix NSLmax(const nsl_matrix&,const nsl_data&);
extern nsl_matrix NSLmax(const nsl_matrix&,const num_type);

// NSLmin
extern num_type NSLmin(const nsl_vector&);
extern num_type NSLmin(const nsl_matrix&);
extern nsl_data NSLmin(const nsl_data&,const nsl_data&);
extern nsl_data NSLmin(const nsl_data&,const num_type);
extern nsl_vector NSLmin(const nsl_vector&,const nsl_vector&);
extern nsl_vector NSLmin(const nsl_vector&,const nsl_data&);
extern nsl_vector NSLmin(const nsl_vector&,const num_type);
extern nsl_matrix NSLmin(const nsl_matrix&,const nsl_matrix&);
extern nsl_matrix NSLmin(const nsl_matrix&,const nsl_data&);
extern nsl_matrix NSLmin(const nsl_matrix&,const num_type);

// vector and matrix transformations
extern nsl_vector NSLmat_to_vec(const nsl_vector&,const nsl_matrix&);
extern nsl_matrix NSLvec_to_mat(const nsl_matrix&,const nsl_vector&);

extern nsl_vector NSLmat_to_col_vec(const nsl_vector&,const nsl_matrix&);
extern nsl_vector NSLmat_to_row_vec(const nsl_vector&,const nsl_matrix&);
extern nsl_matrix NSLcol_vec_to_mat(const nsl_matrix&,const nsl_vector&);
extern nsl_matrix NSLrow_vec_to_mat(const nsl_matrix&,const nsl_vector&);

extern nsl_vector NSLmat_to_col_vec(const nsl_matrix&);
extern nsl_vector NSLmat_to_row_vec(const nsl_matrix&);
extern nsl_matrix NSLcol_vec_to_mat(const nsl_vector&,const int);
extern nsl_matrix NSLrow_vec_to_mat(const nsl_vector&,const int);

// product
extern nsl_data NSLprod(const nsl_vector&,const nsl_vector&);
extern nsl_vector NSLprod(const nsl_vector&,const nsl_matrix&);
extern nsl_vector NSLprod(const nsl_matrix&,const nsl_vector&);
extern nsl_matrix NSLprod(const nsl_matrix&,const nsl_matrix&);

// convolution
extern nsl_vector NSLconv_zero(const nsl_vector&,const num_type);
extern nsl_vector NSLconv_zero(const num_type,const nsl_vector&);
extern nsl_vector NSLconv_zero(const nsl_vector&,const nsl_data&);
extern nsl_vector NSLconv_zero(const nsl_data&,const nsl_vector&);
extern nsl_vector NSLconv_zero(const nsl_vector&,const nsl_vector&);
extern nsl_vector NSLconv_wrap(const nsl_vector&,const nsl_vector&);
extern nsl_vector NSLconv_copy(const nsl_vector&,const nsl_vector&);

extern nsl_matrix NSLconv_zero(const nsl_matrix&,const num_type);
extern nsl_matrix NSLconv_zero(const num_type,const nsl_matrix&);
extern nsl_matrix NSLconv_zero(const nsl_matrix&,const nsl_data&);
extern nsl_matrix NSLconv_zero(const nsl_data&,const nsl_matrix&);
extern nsl_matrix NSLconv_zero(const nsl_matrix&,const nsl_vector&);
extern nsl_matrix NSLconv_zero(const nsl_vector&,const nsl_matrix&);
extern nsl_matrix NSLconv_zero(const nsl_matrix&,const nsl_matrix&);
extern nsl_matrix NSLconv_wrap(const nsl_matrix&,const nsl_matrix&);
extern nsl_matrix NSLconv_copy(const nsl_matrix&,const nsl_matrix&);

extern nsl_matrix NSLexpdecay(const nsl_matrix&,const nsl_data&);
extern nsl_matrix KERNEL(const int,const int,
	const nsl_data&,const nsl_data&,const nsl_data&);

