/* SCCS  %W%---%E%--%U% */
//
//	xnsl_temporal_graph_matrix.C
//

#include "nsl_all_kernel_include.h"
#include "xnsl_all_xkernel_include.h"

extern int TRAIN_FG;

xnsl_temporal_graph_matrix::xnsl_temporal_graph_matrix(xnsl_display_canvas* win,
	nsl_matrix* m) : xnsl_temporal_graph(win)
{
       set_type("temporal_graph_matrix");

	if (m != NULL)
	{
		_layer = m;

		_imax = ((nsl_matrix*) _layer)->get_imax();
		_jmax = ((nsl_matrix*) _layer)->get_jmax();

		_layer0 = new nsl_matrix(_imax,_jmax);

		_i0 = 0;
		_j0 = 0;
		_i1 = _imax - 1;
		_j1 = _jmax - 1;
 	}
//	else
//		cmd_error("xnsl_temporal_graph_mat: NULL layer");
}
xnsl_temporal_graph_matrix::~xnsl_temporal_graph_matrix()
{
}
xnsl_widget * xnsl_temporal_graph_matrix::make_widget()
{
        return new xnsl_temporal_graph_matrix((xnsl_display_canvas*) m_parent,
		(nsl_matrix*) _layer);
}
int xnsl_temporal_graph_matrix::display()
{
//	set_env("",_X0,_Y0,_width,_height,_wx0,_wy0,_wx1,_wy1,_wxs,_wys);
 	display_temporal_graph(_widget,_wx0,_wy0,_wx1,_wy1,_wxs,_wys,_wymin,_wymax);
 	
	return 1;
}
int xnsl_temporal_graph_matrix::display_temporal_graph(xnsl_widget* widget,
	int wx0,int wy0,int wx1,int wy1,int wxs,int wys,
	num_type wymin, num_type wymax) 
{
	float ts;
	float dt;
	
	if (TRAIN_FG == 1) {
		ts = NSL_SYSTEM->getTrainAccumTime();
		dt = NSL_SYSTEM->getTrainDelta();
	} else {
		ts = NSL_SYSTEM->getSimTime();
		dt = NSL_SYSTEM->getSimDelta();
	}
	
	nsl_num_matrix* m0 = ((nsl_matrix*) _layer0);
	nsl_num_matrix* m = ((nsl_matrix*) _layer);

//	draw_temporal_graph_matrix(canvas,m,m0,
//		wx0,wy0,wxs,wys,i0,i1,j0,j1,wymin,wymax,t0,t1,ts,dt,pulsefg);

        int ux0,uy0;
        num_type u0,u1,v0,v1;
        num_type x,y;
        int xc,yc,xp,yp;

        num_type fx0 = get_t0();
        num_type fx1 = get_t1();

        num_type fy0 = wymin;
        num_type fy1 = wymax;

	int i,j;

        for (i = _i0; i <= _i1; i++)
            for (j = _j0; j <= _j1; j++)
            {
//              if (breakfg == 1)
//                  return(1);

                if (ts >= 0.0)
                {
// x,y crossed
/*                  ux0 = wx0 + (i-i0)*wxs;
                    uy0 = wy0 + (j1-j)*wys;
//                  uy0 = wy0 + (j-j0)*wys;
*/
                    ux0 = wx0 + (j-_j0)*wxs;
                    uy0 = wy0 + (_i1-i)*wys;

                    u0 = (num_type) ux0;
                    u1 = (num_type) wxs;
                    v0 = (num_type) uy0;
                    v1 = (num_type) wys;

                    x = ts; 
                    y = (*m)[i][j];
                    xc = coord_transform(x,fx0,fx1,u0,u1);
                    yc = coord_transform(y,fy0,fy1,v0,v1);
                    if (ts == 0.0)
                    {
                        xp = coord_transform(x,fx0,fx1,u0,u1);
                        yp = coord_transform(y,fy0,fy1,v0,v1);
                    }
                    else
                    {
                        x = ts-dt;
                        y = (*m0)[i][j];
                        xp = coord_transform(x,fx0,fx1,u0,u1);
                        yp = coord_transform(y,fy0,fy1,v0,v1);
                    }
// AW98	    	    if (xp != xc || yp != yc)
	    	    {
	        	if (pulsefg == 1)
                	{
                		draw_line(widget,xp,yp,xp,yc);
                		yp = yc;
                    	}
                    	draw_line(widget,xp,yp,xc,yc);
	    	    }
                }
           }

	for (i = 0; i < _imax; i++)
	   for (j = 0; j < _jmax; j++)
		(*m0)[i][j] = (*m)[i][j];

//	*m0 = *m;

	return 1;
}

int xnsl_temporal_graph_matrix::read_from_database()
{
	return 1;
}
int xnsl_temporal_graph_matrix::write_to_database()
{
	return 1;
}
int xnsl_temporal_graph_matrix::print(ostream& out) const
{
	return 1;
}

