/* SCCS  @(#)xnsl_tcltk_canvas.C	1.1---95/08/13--21:01:49 */
//////////////////////////////////////////////////////////////////////////
//
//  xnsl_tcltk_canvas.C: Class that creates the tcltk drawing area widget.
//             
//////////////////////////////////////////////////////////////////////////

#include "nsl_all_kernel_include.h"
#include "xnsl_all_xkernel_include.h"
#include "xnsl_tcltk_include.h"

static void xnslTkExposeEventProc(ClientData clientData, XEvent *eventPtr)
{
/*
	Tk_Window tkmain = Tk_MainWindow(NSL_TCL_INTERP);
	Tk_Window tkwin;
*/	
	xnsl_tcltk_canvas* canvas = (xnsl_tcltk_canvas*) clientData;
	
	nsl_string str;
	strcpy(str, canvas->get_wname());
	
	int width = canvas->get_width();
	int height = canvas->get_height();
	
/*	if (tkmain != NULL)
		tkwin = Tk_NameToWindow(NSL_TCL_INTERP,str,tkmain);
	else
		cmd_error(" xnsl_tcltk_graph::draw_line NULL tkmain");

	if (eventPtr->type == Expose) { // 12 - Expose, 14 - ?
//	   cmd_out("Expose");
	   if (tkmain != NULL && tkwin != NULL) {
		Display* _dpy = Tk_Display(tkwin);		
		Window _xwin = Tk_WindowId(tkwin);
		GC _gc = DefaultGC(_dpy, DefaultScreen(_dpy));
		XCopyArea(_dpy, _pixmap,_xwin,
	        	_gc, 0, 0, width, height, 0, 0);
//		XCopyPlane(_dpy, _pixmap,_xwin,
//	        	_gc, 0, 0, width, height, 0, 0,1);	   
	   }
	}
*/
}


xnsl_tcltk_canvas::xnsl_tcltk_canvas() : xnsl_tcltk_widget()
{
	set_type("canvas");
}  

xnsl_tcltk_canvas::~xnsl_tcltk_canvas()
{
}  

int xnsl_tcltk_canvas::clear_area(xnsl_widget* widget,int wx0,int wy0,int wx1,int wy1,int fg)
{
//	(wx0,wy0) is lower left corner.
//	 wx1: width, wy1: height

	nsl_string str;

	sprintf(str,"%s",_wname); 

	Tk_Window tkmain = Tk_MainWindow(NSL_TCL_INTERP);
	Tk_Window tkwin = 0;

	if (tkmain != NULL)
		tkwin = Tk_NameToWindow(NSL_TCL_INTERP,str,tkmain);
	else
		cmd_error(" xnsl_tcltk_graph::draw_line NULL tkmain");

	if (tkmain != NULL && tkwin != NULL) {
		_sc = Tk_Screen(tkwin);
		_dpy = Tk_Display(tkwin);
		_xwin = Tk_WindowId(tkwin);
//		_gc = DefaultGC(_dpy, DefaultScreen(_dpy));
#ifdef NSL_PC
			_gc = XCreateGC(_dpy, _xwin, 0, NULL);
#else
			_gc = ((xnsl_tcltk_widget*) widget)->get_GC(); // DefaultGC(_dpy, DefaultScreen(_dpy));
#endif

		// SET GC WHITE FOR DRAWING
		XSetForeground(_dpy,_gc,WhitePixelOfScreen(_sc));
		XFillRectangle(_dpy,_xwin,_gc,wx0,wy0,wx1,wy1);
//		XFillRectangle(_dpy,_pixmap,_gc,wx0,wy0,wx1,wy1);
	}
	else
		cmd_error(" xnsl_tcltk_graph::clear_area NULL tkwin");
	
//	nsl_string str;
//	char c = ' '; // 'p' // printer points

//	clear_area(widget,wx0,wy0,wx1,wy1);

// AW99
/*	sprintf(str,"%s create rectangle %d%c %d%c %d%c %d%c -fill white" \
		,_wname,wx0,c,wy0,c,wx0+wx1,c,wy0+wy1,c);

	Tcl_Eval(NSL_TCL_INTERP,str);
*/
	return 1;
}
void  xnsl_tcltk_canvas::redraw()
{
//     XCopyPlane(XtDisplay(_object), _xwin,XtWindow(_object),
//        _gc, 0, 0, _width,_height, 0, 0, 1);
//	if (NSL_TK_FLUSH == 1)
		Tcl_Eval(NSL_TCL_INTERP,"update"); // idletasks
}
	
xnsl_widget*  xnsl_tcltk_canvas::create_widget(const char   *wname, 
	xnsl_widget     *pxnsl_widget, int, int,
	int width, int height, int, int, int, int, int, int,
	const char* side, const char*) // side taken from label
{
     strcpy(_wname,wname);
     _width = width;
     _height = height;

	nsl_string str;

	char c = ' '; // 'p'

/*	sprintf(str,"frame %s -relief groove -borderwidth 4",wname);

	Tcl_Eval(NSL_TCL_INTERP,str);

	sprintf(str,"pack %s -side %s",wname,side); // left, top

	Tcl_Eval(NSL_TCL_INTERP,str);
*/
	sprintf(str,"canvas %s -width %d%c -height %d%c -background white",wname,_width,c,_height,c);

	Tcl_Eval(NSL_TCL_INTERP,str);

	sprintf(str,"pack %s -side %s",wname,side); // left, top
	// sprintf(str,"pack %s",wname);

	Tcl_Eval(NSL_TCL_INTERP,str);

	_tkmain = Tk_MainWindow(NSL_TCL_INTERP);

	if (_tkmain != NULL)
		_tkwin = Tk_NameToWindow(NSL_TCL_INTERP,_wname,_tkmain);
	else
		cmd_error(" xnsl_tcltk_graph::draw_line NULL tkmain");

	if (_tkmain != NULL && _tkwin != NULL) {
//		Tk_CreateEventHandler(_tkwin,ExposureMask,xnslTkExposeEventProc,this);
		_sc = Tk_Screen(_tkwin);
		_xwin = Tk_WindowId(_tkwin);
		_dpy = Tk_Display(_tkwin);
#ifndef NSL_PC
		_scnum = Tk_ScreenNumber(_tkwin);
		_depth = Tk_Depth(_tkwin);
		_gc = DefaultGC(_dpy, DefaultScreen(_dpy));	
#else
		_gc = XCreateGC(_dpy, _xwin, 0, NULL);
#endif		
//		_pixmap = XCreatePixmap(_dpy,_xwin,_width,_height,_depth);
//		_pixmap = XCreatePixmap(_dpy,RootWindow(_dpy,n),_width,_height,_depth);
	}
	
   	return (this);

}   // End function create_widget
/*
void xnsl_tcltk_canvas::set_env (const char	*wname,
	int	x,int	y,int	width,int	height,
	int,int,int,int,int,int,const char* label, const char* message)
{
    	strcpy(_wname,wname);
	_X0		= x;
	_Y0		= y;
	_width		= width;
	_height		= height;

}  // End of function set_canvas_env
*/				

/////////////////////////////////////////////////////////////////////////////
//
//	Function :   	make_widget
//
////////////////////////////////////////////////////////////////////////////

xnsl_widget *xnsl_tcltk_canvas::make_widget()
{
	return new xnsl_tcltk_canvas();
}
			

// End of file.


